package de.vernideas.mc.taverns;

import net.minecraftforge.common.Configuration;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import de.vernideas.mc.common.CommonSidedProxy;
import de.vernideas.mc.taverns.gen.BarnCreationHandler;
import de.vernideas.mc.taverns.gen.ComponentVillageBarn;
import de.vernideas.mc.taverns.gen.ComponentVillageStall;
import de.vernideas.mc.taverns.gen.ComponentVillageTavern;
import de.vernideas.mc.taverns.gen.StallCreationHandler;
import de.vernideas.mc.taverns.gen.TavernCreationHandler;
import de.vernideas.mc.taverns.trader.VillageHandlerBarWench;
import de.vernideas.mc.taverns.trader.VillageHandlerHostler;
import de.vernideas.mc.taverns.trader.VillageHandlerShepherdess;

/**
* Taverns
* <p>
* Modified by Akjosch for Minecraft version 1.6.4
*
* @author AngleWyrm, Akjosch
* @license Lesser GNU Public License v3 (http://www.gnu.org/licenses/lgpl.html)
*
*/
@Mod(modid = Taverns.modID, name = Taverns.modName, version = Taverns.modVersion)
public class Taverns
{
    @Instance public static Taverns instance;
    
    @SidedProxy(clientSide = "de.vernideas.mc.common.client.ClientProxy",
    		serverSide = "de.vernideas.mc.common.server.ServerProxy")
    public static CommonSidedProxy sidedProxy;
    
    public static final String modID = "taverns";
    public static final String modName = "Village Taverns";
    public static final String modVersion = "2.1.3-1";
    
    public static Settings config;
    
    @EventHandler
    public void preInit(FMLPreInitializationEvent event)
    {
    	config = new Settings(new Configuration(event.getSuggestedConfigurationFile()));
        if( config.generateTaverns )
        {
        	if( config.barWenchID > 0 )
        	{
        		VillageHandlerBarWench.init(config);
        	}
        	TavernCreationHandler.init(config);
			ComponentVillageTavern.init(config);
        }
        if( config.generateBarns )
        {
        	if( config.shepherdessID > 0 )
        	{
    			VillageHandlerShepherdess.init(config);
        	}
        	BarnCreationHandler.init(config);
			ComponentVillageBarn.init(config);
        }
        if( config.generateStalls )
        {
        	if( config.hostlerID > 0 )
        	{
    			VillageHandlerHostler.init(config);
        	}
        	StallCreationHandler.init(config);
			ComponentVillageStall.init(config);
        }
    }
}
