package de.vernideas.mc.taverns.gen;

import java.util.List;
import java.util.Random;

import net.minecraft.util.MathHelper;
import net.minecraft.world.gen.structure.ComponentVillageStartPiece;
import net.minecraft.world.gen.structure.StructureVillagePieceWeight;
import cpw.mods.fml.common.FMLLog;
import cpw.mods.fml.common.registry.VillagerRegistry;
import cpw.mods.fml.common.registry.VillagerRegistry.IVillageCreationHandler;
import de.vernideas.mc.taverns.Settings;
import de.vernideas.mc.taverns.Taverns;

public class BarnCreationHandler implements IVillageCreationHandler
{
	public static BarnCreationHandler instance = null;
	
	public static void init(Settings config)
	{
		if( null == instance )
		{
			instance = new BarnCreationHandler();
			VillagerRegistry.instance().registerVillageCreationHandler(instance);
		}
	}

	@Override
	public StructureVillagePieceWeight getVillagePieceWeight(Random random, int i)
	{
        return new StructureVillagePieceWeight(ComponentVillageBarn.class, Taverns.config.weightBarns,
        		MathHelper.getRandomIntegerInRange(random, 0, 2));
	}

	@Override
	public Class<?> getComponentClass()
	{
		return ComponentVillageBarn.class;
	}

	@Override
	public Object buildComponent(StructureVillagePieceWeight villagePiece,
			ComponentVillageStartPiece startPiece, List pieces, Random random,
			int p1, int p2, int p3, int p4, int p5)
	{
        return ComponentVillageBarn.buildComponent(startPiece, pieces, random, p1, p2, p3, p4, p5);
	}

}
