package de.vernideas.mc.taverns.trader;

import gaia.GaiaItem;

import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraft.village.MerchantRecipe;
import net.minecraft.village.MerchantRecipeList;
import cpw.mods.fml.common.registry.VillagerRegistry;
import cpw.mods.fml.common.registry.VillagerRegistry.IVillageTradeHandler;
import de.vernideas.mc.taverns.Settings;
import de.vernideas.mc.taverns.Taverns;

public class VillageHandlerHostler extends VillageHandlerBase implements IVillageTradeHandler
{
	public static VillageHandlerHostler villageHandler = null;
	
	public static void init(Settings config)
	{
		if( null == villageHandler )
		{
			villageHandler = new VillageHandlerHostler();
			VillagerRegistry.instance().registerVillagerId(config.hostlerID);
			VillagerRegistry.instance().registerVillageTradeHandler(config.hostlerID, villageHandler);
			VillagerRegistry.instance().registerVillagerSkin(config.hostlerID,
					new ResourceLocation(Taverns.modID, "textures/entity/village_hostler.png"));
		}
	}

	@Override
	public void manipulateTradesForVillager(EntityVillager villager, MerchantRecipeList recipeList, Random random)
	{
		ItemStack emeraldShard = null;
		if( Taverns.config.grimoireOfGaia2 )
		{
			emeraldShard = new ItemStack(GaiaItem.ShardEmerald, 1);
		}
		
		// Sell
		recipeList.add(new MerchantRecipe(emerald, randomItem(Item.leash, 12, 16, random)));
		addRandomTrade(recipeList, emerald, randomItem(Block.hay, 3, 5, random), 0.9, random);
		addRandomTrade(recipeList, emerald, randomItem(Item.appleRed, 8, 12, random), 0.9, random);
		addRandomTrade(recipeList, emerald, new ItemStack(Item.saddle, 1), 0.9, random);
		addRandomTrade(recipeList, new ItemStack(Item.emerald, 3), new ItemStack(Item.horseArmorIron), 0.5, random);
		addRandomTrade(recipeList, emerald, new ItemStack(Item.nameTag, 1), 0.5, random);
		addRandomTrade(recipeList, emerald, new ItemStack(Item.goldenCarrot, 1), 0.3, random);
		
		// Buy
		addRandomTrade(recipeList, randomItem(Item.slimeBall, 12, 20, random), emerald, 0.9, random);
		addRandomTrade(recipeList, randomItem(Item.wheat, 18, 22, random), emerald, 0.9, random);
		
		if( Taverns.config.grimoireOfGaia2 )
		{
			addRandomTrade(recipeList, emeraldShard,  randomItem(Item.leash, 3, 4, random), 0.9, random);
			addRandomTrade(recipeList, emeraldShard, new ItemStack(Block.hay, 1), 0.9, random);
			addRandomTrade(recipeList, emeraldShard, randomItem(Item.appleRed, 2, 3, random), 0.9, random);
			addRandomTrade(recipeList, randomItem(Item.slimeBall, 3, 5, random), emeraldShard, 0.9, random);
			addRandomTrade(recipeList, randomItem(Item.wheat, 4, 6, random), emeraldShard, 0.9, random);
		}
	}

}
